using System;
using System.Collections.Generic;
using Jypeli;
using Jypeli.Assets;
using Jypeli.Controls;
using Jypeli.Widgets;

namespace demo_7_tehtävä_4_5;

/// @author konst
/// @version 01.03.2025
/// <summary>
/// 
/// </summary>
public class Lahinpallo : PhysicsGame
{
    public override void Begin()
    {
        SetWindowSize(800, 600);
        Level.Size = new Vector(800, 600);
        PhysicsObject[] pallot = TeeSatunnaisetPallot(20, 30.0);
        PhysicsObject sininenPallo = new PhysicsObject(20,20, Shape.Circle);
        sininenPallo.Color = Color.Blue;
        Add(sininenPallo);
        Mouse.IsCursorVisible = true;

        Mouse.Listen(MouseButton.Left, ButtonState.Pressed, delegate ()
        {
            Vector paikkaKentalla = Mouse.PositionOnWorld;
            sininenPallo.Position = paikkaKentalla;
            foreach (PhysicsObject pallo in pallot)
            {
                pallo.Color = Color.White;
            }
            PhysicsObject lahinpallo = LahinPallo(pallot, sininenPallo.Position);
            lahinpallo.Color = Color.Red;
        }, "");
        PhysicsObject lahinPallo = LahinPallo(pallot, sininenPallo.Position);
        lahinPallo.Color = Color.Red;

        Keyboard.Listen(Key.Escape, ButtonState.Pressed, ConfirmExit, "Lopeta peli");
    }

    /// <summary>
    /// Tekee palloja satunnaisiin paikkoihin
    /// </summary>
    /// <param name="montako">Montako palloa tehdään</param>
    /// <param name="koko">Pallon koko</param>
    /// <returns>Pallot</returns>
    private PhysicsObject[] TeeSatunnaisetPallot(int montako, double koko)
    {
        PhysicsObject[] pallot = new PhysicsObject[montako];
        for (int i = 0; i < montako; i++)
        {
            PhysicsObject p = new PhysicsObject(koko, koko, Shape.Circle);
            pallot[i] = p;
            p.Position = RandomGen.NextVector(Level.BoundingRect);
            Add(p);
        }
        return pallot;
    }
    public PhysicsObject LahinPallo(PhysicsObject[] pallot, Vector piste)
    {
        PhysicsObject lahin = pallot[0];
        double pieninEtaisyys = (lahin.Position - piste).Magnitude;

        foreach (PhysicsObject pallo in pallot)
        {
            double etaisyys = (pallo.Position - piste).Magnitude;
            if (etaisyys < pieninEtaisyys)
            {
                lahin = pallo;
                pieninEtaisyys = etaisyys;
            }
        }
        return lahin;
        {
            
        }
    }
}

